HDU 3308 线段树单点更新+区间查找最长连续子序列

LCIS

                                                             Time Limit: 6000/2000 MS (Java/Others)    

                                                            Memory Limit: 65536/32768 K (Java/Others)
                                                            Total Submission(s): 5591    Accepted Submission(s): 2443

Problem Description

Given n integers.
You have two operations:
U A B: replace the Ath number by B. (index counting from 0)
Q A B: output the length of the longest consecutive increasing subsequence (LCIS) in [a, b].

Input

T in the first line, indicating the case number.
Each case starts with two integers n , m(0<n,m<=105).
The next line has n integers(0<=val<=105).
The next m lines each has an operation:
U A B(0<=A,n , 0<=B=105)
OR
Q A B(0<=A<=B< n).

Output

For each Q, output the answer.

Sample Input

1
10 10
7 7 3 3 5 9 9 8 1 8
Q 6 6
U 3 4
Q 0 1
Q 0 5
Q 4 7
Q 3 5
Q 0 2
Q 4 6
U 6 10
Q 0 9

Sample Output

1
1
4
2
3
1
2
5

Author

shǎ崽

题解:开始看错题,以为是最长子序列,GG,

后知后觉,线段树秒了

///1085422276
#include<iostream>
#include<cstdio>
#include<cstring>
#include<string>
#include<algorithm>
#include<queue>
#include<cmath>
#include<map>
#include<bitset>
#include<set>
#include<vector>
using namespace std ;
typedef long long ll;
#define mem(a) memset(a,0,sizeof(a))
#define meminf(a) memset(a,127,sizeof(a))
#define memfy(a)  memset(a,-1,sizeof(a))
#define TS printf("111111\n");
#define FOR(i,a,b) for( int i=a;i<=b;i++)
#define FORJ(i,a,b) for(int i=a;i>=b;i--)
#define READ(a,b) scanf("%d%d",&a,&b)
#define mod 1000000007
#define inf 1000000001
#define maxn 200000+2
inline ll read()
{
    ll x=0,f=1;
    char ch=getchar();
    while(ch<‘0‘||ch>‘9‘)
    {
        if(ch==‘-‘)f=-1;
        ch=getchar();
    }
    while(ch>=‘0‘&&ch<=‘9‘)
    {
        x=x*10+ch-‘0‘;
        ch=getchar();
    }
    return x*f;
}
//****************************************
struct ss
{
    int l,r,v,ans;
    int lc,rc;
}tr[maxn<<2];
int a[maxn<<2],n,q;
void push_up(int k)
{
    if(a[tr[k<<1].r]<a[tr[k<<1|1].l])
    {
        tr[k].ans=max(max(tr[k<<1].ans,tr[k<<1|1].ans),tr[k<<1].rc+tr[k<<1|1].lc);
        if(tr[k<<1].lc==(tr[k<<1].r-tr[k<<1].l+1))
        {
            tr[k].lc=tr[k<<1].lc+tr[k<<1|1].lc;
        }else  tr[k].lc=tr[k<<1].lc;
        if(tr[k<<1|1].lc==(tr[k<<1|1].r-tr[k<<1|1].l+1))
        {
             tr[k].rc=tr[k<<1|1].rc+tr[k<<1].rc;
        }else  tr[k].rc=tr[k<<1|1].rc;
    }
    else
    {
        tr[k].ans=max(tr[k<<1].ans,tr[k<<1|1].ans);
        tr[k].lc=tr[k<<1].lc;
        tr[k].rc=tr[k<<1|1].rc;
    }
}
void build(int k,int s,int t)
{
    tr[k].l=s;
    tr[k].r=t;
    if(s==t)
    {
        tr[k].v=a[s];
        tr[k].ans=1;
        tr[k].lc=1;
        tr[k].rc=1;
        return ;
    }
    int mid=(s+t)>>1;
    build(k<<1,s,mid);
    build(k<<1|1,mid+1,t);
    push_up(k);
}
void update(int k,int x,int c)
{
    if(tr[k].l==x&&tr[k].r==x)
    {
        tr[k].v=c;
        a[x]=c;
        return ;
    }
    int mid=(tr[k].l+tr[k].r)>>1;
    if(x<=mid)update(k<<1,x,c);
    else update(k<<1|1,x,c);
    push_up(k);
}
int ask(int k,int s,int t)
{
    if(tr[k].l==s&&tr[k].r==t)
    {
        return tr[k].ans;
    }
    int mid=(tr[k].l+tr[k].r)>>1;
    if(t<=mid)return ask(k<<1,s,t);
    else if(s>mid)return ask(k<<1|1,s,t);
    else {
      int ret=0;
      int A=ask(k<<1,s,mid);
      int B=ask(k<<1|1,mid+1,t);
      ret=max(A,B);
      A=min(tr[k<<1].rc,mid-s+1);
      B=min(tr[k<<1|1].lc,t-mid);
         if(a[tr[k<<1].r]<a[tr[k<<1|1].l])
                ret=max(A+B,ret);
      return ret;
    }
}
int main()
{

    int T=read();
    while(T--)
    {
        n=read();
        q=read();
        FOR(i,1,n)
        {
            a[i]=read();
        }
        build(1,1,n);
        int a,b;
        char ch[321];
        FOR(i,1,q)
        {
            scanf("%s%d%d",ch,&a,&b);
            if(ch[0]==‘Q‘)
            {
                printf("%d\n",ask(1,a+1,b+1));
            }
            else update(1,a+1,b);
        }
    }
    return 0;
}

代码

时间: 2024-11-03 20:55:43

HDU 3308 线段树单点更新+区间查找最长连续子序列的相关文章

hdu 3308 线段树单点更新 区间合并

http://acm.hdu.edu.cn/showproblem.php?pid=3308 学到两点: 1.以区间端点为开始/结束的最长......似乎在Dp也常用这种思想 2.分类的时候,明确标准逐层分类,思维格式: 条件一成立: { 条件二成立: { } else { } } else { 条件二成立: { } else { } } 上面的这种方式很清晰,如果直接想到那种情况iif(条件一 &条件二)就写,很容易出错而且把自己搞乱,或者情况不全,,,我就因为这WA了几次 3.WA了之后 ,

HDU 4302 线段树单点更新,维护区间最大最小值

http://acm.hdu.edu.cn/showproblem.php?pid=4302 Problem Description Holedox is a small animal which can be considered as one point. It lives in a straight pipe whose length is L. Holedox can only move along the pipe. Cakes may appear anywhere in the p

【HDU】1754 I hate it ——线段树 单点更新 区间最值

I Hate It Time Limit: 9000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 37448    Accepted Submission(s): 14816 Problem Description 很多学校流行一种比较的习惯.老师们很喜欢询问,从某某到某某当中,分数最高的是多少.这让很多学生很反感. 不管你喜不喜欢,现在需要你做的是,就是按照老师的要

HDU 1394(线段树单点更新)

题意:就是给出一串数,当依次在将第一个数变为最后一个数的过程中,要你求它的最小逆序数. 思路:可以用树状数组和线段数做.这里我是用线段树做的.建的是一棵空树,然后每插入一个点之前,统计大于这个数的有多少个,直到所有的数都插入完成,就结果了逆序树的统计. 要得出答案主要是利用了一个结论,如果是0到n的排列,那么如果把第一个数放到最后,对于这个数列,逆序数是减少a[i],而增加n-1-a[i]的. #include<iostream> #include<cstring> #includ

HDU 3308 LCIS (线段树&#183;单点更新&#183;区间合并)

题意  给你一个数组  有更新值和查询两种操作  对于每次查询  输出对应区间的最长连续递增子序列的长度 基础的线段树区间合并  线段树维护三个值  对应区间的LCIS长度(lcis)  对应区间以左端点为起点的LCIS长度(lle)  对应区间以右端点为终点的LCIS长度(lri)  然后用val存储数组对应位置的值  当val[mid + 1] > val[mid] 的时候就要进行区间合并操作了 #include <cstdio> #include <algorithm>

hdu - 4973 - A simple simulation problem.(线段树单点更新 + 区间更新)

题意:初始序列 1, 2, ..., n,m次操作(1 <= n,m<= 50000),每次操作可为: D l r,将区间[l, r]中的所有数复制一次: Q l r,输出区间[l, r]中同一数字个数的最大值. (0 <= r – l <= 10^8, 1 <= l, r <= 序列元素个数) 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4973 -->>因为区间内数字是依次递增的,所以可以以数字为叶建线段

hdu2795(线段树单点更新&amp;区间最值)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2795 题意:有一个 h * w 的板子,要在上面贴 n 条 1 * x 的广告,在贴第 i 条广告时要尽量将其靠上贴,并输出其最上能贴在哪个位置: 思路:可以将每行剩余空间大小存储到一个数组中,那么对于当前 1 * x 的广告,只需找到所有剩余空间大于的 x 的行中位置最小的即可: 不过本题数据量为 2e5,直接暴力因该会 tle.可以用个线段树维护一下区间最大值,然后查询时对线段树二分即可: 代码

HDU 2795 Billboard (线段树 单点更新 区间求最大值)

题目连接:http://acm.hdu.edu.cn/showproblem.php?pid=2795 题意:有一块h*w 的广告版,有n块1*w[i]的广告,就着放广告尽量在顶上,尽量先放左边的原则,问在第几行能把广告放下,如果放不下,就打印-1: 思路:我们可以根据每一行建树,每一个子叶表示每一行的容量,而节点存放子节点的最大值,然后从最顶到底,快速查找能存放下广告的一行. 总之还是简单的线段树问题,难点在于抽象模型. #include <iostream> #include <cs

HDU 1540 Tunnel Warfare(线段树单点更新+区间合并)

Problem Description During the War of Resistance Against Japan, tunnel warfare was carried out extensively in the vast areas of north China Plain. Generally speaking, villages connected by tunnels lay in a line. Except the two at the ends, every vill